#include <ggi/ggiart.h>
/* gcc test1.c -o test1 -lart_lgpl -lggi -lggiart */

int main() {

  
  ggi_visual_t vis;
  ggi_color color;
  ggi_color color2;
  ggi_mode mode;
  ArtVpath * vp;
  ArtSVP   * svp2;
  ArtSVP   * svp;
  ArtUta   * uta;
  ArtUta   * uta2;

  struct ggiart_rop_s rops;
  struct ggiart_rop_s rops2;
  

  rops.rop=GGIART_ROP_COLOR;
  rops.arg1=(void*)(&color);
  rops2.rop=GGIART_ROP_COLOR;
  rops2.arg1=(void*)(&color2);
  

  ggiInit();
  ggiartInit();
  vis=ggiOpen(NULL);
  
  ggiCheckGraphMode(vis,GGI_AUTO,GGI_AUTO,GGI_AUTO,GGI_AUTO,GGI_AUTO,&mode);
  ggiSetMode(vis,&mode);

  ggiartAttach(vis);

  ggiAddFlags(vis, GGIFLAG_ASYNC);
  
  vp  = art_vpath_new_circle(50,50,45);
  svp = art_svp_vpath_stroke(vp,ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,1,4,3);
  uta = art_uta_from_svp(svp);

  color.r=0xffff; color.g=0xffff; color.b=0xffff;

  ggiSetGCForeground(vis,ggiMapColor(vis,&color));
  ggiFillscreen(vis);
  ggiFlush(vis);

  color.r=0xffff; color.g=0x0; color.b=0x0; color.a=0xffff;

  ggiartRenderSVP(vis,svp,NULL,&rops);
  ggiFlush(vis);
  
  color.a=0xafff; color.g+=0xafff;

  vp  = art_vpath_new_circle(75,75,45);
  svp = art_svp_vpath_stroke(vp,ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,4.5,4,3);
  uta = art_uta_from_svp(svp);
  ggiartRenderSVP(vis,svp,NULL,&rops);

  ggiFlush(vis);

  color.a=0x8fff; color.g-=0xafff; color.r-=0x3f00; color.b+=0x3f00;
  
  vp  = art_vpath_new_circle(100,100,45);
  svp = art_svp_vpath_stroke(vp,ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,3,4,3);
  uta = art_uta_from_svp(svp);
  ggiartRenderSVP(vis,svp,NULL,&rops);
  ggiFlush(vis);
  
  color.a=0x4fff; color.r-=0x3f00; color.b+=0x3f00;
  color2=color;
  vp  = art_vpath_new_circle(125,125,45);
  svp2 = art_svp_vpath_stroke(vp,ART_PATH_STROKE_JOIN_MITER,
			      ART_PATH_STROKE_CAP_SQUARE,4,4,3);
  uta2 = art_uta_from_svp(svp2);
  ggiartRenderSVP(vis,svp2,NULL,&rops2);
  
  ggiFlush(vis);
  
  color.a=0x1fff; color.r-=0x3f00; color.b+=0x3f00;
  vp  = art_vpath_new_circle(150,150,45);
  svp = art_svp_vpath_stroke(vp,ART_PATH_STROKE_JOIN_MITER,
			     ART_PATH_STROKE_CAP_SQUARE,5,4,3);
  uta = art_uta_from_svp(svp);
  ggiartRenderSVP(vis,svp,NULL,&rops);
  
  ggiFlush(vis);
  ggiGetc(vis);
  color.r=0xffff; color.g=0xffff; color.b=0xffff;
  ggiartFillscreen(vis,uta);
  ggiFlush(vis);
  ggiGetc(vis);

  
  ggiartRenderSVP(vis,svp2,uta,&rops2);
  ggiFlush(vis);
  ggiGetc(vis);

  color.a=0xffff; color.r=0x0; color.g=0x0; color.b=0xffff;

  ggiartRenderSVP(vis,svp,uta,&rops);
  ggiFlush(vis);
  ggiGetc(vis);
  
  ggiartDetach(vis);

  ggiClose(vis);
  ggiartExit();
  ggiExit();

  return 0;
}
